"""
FieldsTag automatically generated by SDKgen please do not edit this file manually
https://sdkgen.app
"""

import requests
import sdkgen
from requests import RequestException
from typing import List

from .error_exception import ErrorException
from .field import Field

class FieldsTag(sdkgen.TagAbstract):
    def __init__(self, http_client: requests.Session, parser: sdkgen.Parser):
        super().__init__(http_client, parser)


    def create(self, base_id: str, table_id: str, payload: Field) -> Field:
        try:
            path_params = {}
            path_params["baseId"] = base_id
            path_params["tableId"] = table_id

            query_params = {}

            query_struct_names = []

            url = self.parser.url("/v0/meta/bases/:baseId/tables/:tableId/fields", path_params)

            headers = {}
            headers["Content-Type"] = "application/json"

            response = self.http_client.post(url, headers=headers, params=self.parser.query(query_params, query_struct_names), json=payload.model_dump(by_alias=True))

            if response.status_code >= 200 and response.status_code < 300:
                return Field.model_validate_json(json_data=response.content)

            if response.status_code == 400:
                raise ErrorException(response.content)
            if response.status_code == 403:
                raise ErrorException(response.content)
            if response.status_code == 404:
                raise ErrorException(response.content)
            if response.status_code == 500:
                raise ErrorException(response.content)

            raise sdkgen.UnknownStatusCodeException("The server returned an unknown status code")
        except RequestException as e:
            raise sdkgen.ClientException("An unknown error occurred: " + str(e))

    def update(self, base_id: str, table_id: str, column_id: str, payload: Field) -> Field:
        try:
            path_params = {}
            path_params["baseId"] = base_id
            path_params["tableId"] = table_id
            path_params["columnId"] = column_id

            query_params = {}

            query_struct_names = []

            url = self.parser.url("/v0/meta/bases/:baseId/tables/:tableId/fields/:columnId", path_params)

            headers = {}
            headers["Content-Type"] = "application/json"

            response = self.http_client.patch(url, headers=headers, params=self.parser.query(query_params, query_struct_names), json=payload.model_dump(by_alias=True))

            if response.status_code >= 200 and response.status_code < 300:
                return Field.model_validate_json(json_data=response.content)

            if response.status_code == 400:
                raise ErrorException(response.content)
            if response.status_code == 403:
                raise ErrorException(response.content)
            if response.status_code == 404:
                raise ErrorException(response.content)
            if response.status_code == 500:
                raise ErrorException(response.content)

            raise sdkgen.UnknownStatusCodeException("The server returned an unknown status code")
        except RequestException as e:
            raise sdkgen.ClientException("An unknown error occurred: " + str(e))


